import java.util.LinkedList;
import java.util.Scanner;

public class Main {
    
    
    
    
    
    static int brojPlazmiTogDana(int brojDana, LinkedList<Dan> listaDana){
        int brojPlazmi = 0;
        int i = 0;
        while(i < listaDana.size()){
            if(listaDana.get(i).kojiDan == brojDana){
                brojPlazmi += listaDana.get(i).brojPlazmi;
                break;
            }
            
            i += 1;
        }
        
        return brojPlazmi;
    }
    
    static int kolikoJePojelaPlazmi(int doKogDana, LinkedList<Dan> listaDana){
        int pojedenoPlazmi = 0;
        int i = 0;
        int trenutniBrojPlazmi = 0;
        while(i < doKogDana){
            trenutniBrojPlazmi += brojPlazmiTogDana(i + 1, listaDana);
            if(trenutniBrojPlazmi > 0){
                trenutniBrojPlazmi -= 1;
                pojedenoPlazmi += 1;
            }
            
            i += 1;
        }
        
        return pojedenoPlazmi;
    }

    public static void main(String[] args) {
        int n; // nasao plazmu
        int q; // pitanja
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        q = in.nextInt();
        LinkedList<Dan> listaDana = new LinkedList<>();
        LinkedList<Integer> listaPitanja = new LinkedList<>();
        int i = 0;
        while(i < n){
            int kojiDan = in.nextInt();
            int brojPlazmi = in.nextInt();
            listaDana.add(new Dan(kojiDan, brojPlazmi));

            i += 1;
        }
        i = 0;
        int count = 0; // broj plazmi trenutno
        while(i < q){
            listaPitanja.add(in.nextInt());
            
            i += 1;
        }
        i = 0;
        while(i < listaPitanja.size()){
            int t = listaPitanja.get(i);
            
            int pojedenoPlazmi = kolikoJePojelaPlazmi(t, listaDana);
            System.out.println(pojedenoPlazmi);
            
            i += 1;
        }
    }
    
}

class Dan{
    int kojiDan;
    int brojPlazmi;

    public Dan(int kojiDan, int brojPlazmi) {
        this.kojiDan = kojiDan;
        this.brojPlazmi = brojPlazmi;
    }
    
}